﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace Barsalt.MessageServiceSystem {
	public class Message {
		#region DELEGATE
		//==========================================================================
		public delegate void MessageHandler(Message message);
		//==========================================================================
		#endregion

		#region STRUCT_ATTRIBUTES
		//==========================================================================
		private readonly LogType TYPE;
		private readonly string MESSAGE;
		private readonly string STACK_TRACE;
		//==========================================================================
		#endregion

		#region CONSTRUCTOR
		//==========================================================================
		public Message(LogType type, string message) {
			this.TYPE			= type;
			this.MESSAGE		= message;
			this.STACK_TRACE	= null;
		}

		public LogType Type{
			get{
				return TYPE;
			}
		}

		public string Content{
			get{
				return MESSAGE;
			}
		}

		public string StackTrace{
			get{
				return STACK_TRACE;
			}
		}
		//==========================================================================
		#endregion
	}
}
