﻿using Barsalt.MessageServiceSystem;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Barsalt.MessageServiceSystem.Services {
	public class HelpService : IMessageService {
		#region OBJECT_ATTRIBUTES
		//==========================================================================
		private readonly MessageServiceManager MANAGER	= null;
		//==========================================================================
		#endregion

		#region OBJECT_CONSTRUCTOR
		//==========================================================================
		public HelpService(MessageServiceManager manager){
			this.MANAGER = manager;
		}
		//==========================================================================
		#endregion

		#region OBJECT_FUNCTIONS
		//==========================================================================
		public Message ProcessMessage(string[] parameters) {
			if(parameters.Length > 0 && parameters[0].Equals("services", StringComparison.OrdinalIgnoreCase)){
				return GetServices();
			} else {
				return GetCommands();
			}
		}

		private Message GetCommands(){
			return new Message(UnityEngine.LogType.Log, "[HELP COMMANDS]\n- services\n");
		}

		private Message GetServices() {
			string message = "[SERVICES]\n";

			for(int index = 0; index < MANAGER.Services.Length; index++) {
				
				IMessageService service = MANAGER[MANAGER.Services[index]];
				
				if(service != this){
					message += "- " + MANAGER.Services[index] + "\n";
				}
			}

			return new Message(UnityEngine.LogType.Log, message);
		}
		//==========================================================================
		#endregion

		#region GETTER_AND_SETTER
		//==========================================================================
		public string GetInformation() {
			return "The help service provides information about the registered services and commands that are possible";
		}
		//==========================================================================
		#endregion
	}
}
