﻿using Barsalt.MessageServiceSystem;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Barsalt.MessageServiceSystem.Services {
	public interface IMessageService {
		/// <summary>
		/// Is called by the MessageService for each registered service based on the name with which the service is registered
		/// </summary>
		/// <param name="parameters">the message</param>
		/// <returns></returns>
		Message ProcessMessage(string[] parameters);
		
		/// <summary>
		/// Should return a a text that explains what the implementing service does
		/// </summary>
		/// <returns>the information</returns>
		string GetInformation();
	}
}
